;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Patch BSrom140 for ESXDOS ;;
;; 10.07.2022 ;;;; Busy soft ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; Make:
;;  1, Copy original BSrom140 to Bs140esx.rom
;;  2. Compile this source in SjASMPlus 1.20.x
;;     (https://github.com/z00m128/sjasmplus)

	OUTPUT	Bs140esx.rom ,r

	FPOS	#66		;; NMI handler

	push	af
	push	hl
	jp	#3933


	FPOS	#1287		;; System initialization

	ld	(IY+#31),#02
	call	#053F		;; Set border
	call	init		;; Next init's
	xor	a
	call	#1601		;; Open channel 'K'
	xor	a
	ld	DE,#3CA5	;; Print init message
	call	#0C0A
	set	5,(IY+#02)
	jr	$+9


	FPOS	#1B44		;; Basic commands processing
	dw	test


	FPOS	#3CB9		;; Place for patches
	ORG	#3CB9
	dc	'for ESXDOS  '	;; Continuation of init message

test	cp	'.'		;; Make error in case of '.' as basic command
	jp	nz,#3B22	;; It allows proper processing of dot commands in esxdos
	rst	#08
	db	#0B

init	call	#3B58		;; Reset hardware (including AY quiet)
	call	#16B0		;; Init workspace (needed for memory info)
	jp	#3C0B		;; Print memory info Prog: Vars: Free:
